{ ============================================================================== }
{ Copyright(c) 1996-2009 InstallAware Software Corporation. All rights reserved. }
{ This source code provided for demonstrative use only. All rights reserved.     }
{ ============================================================================== }

library mEXEPlug;

uses
  Classes,
  Windows,
  SysUtils,
  uSharedDLL in 'uSharedDLL.pas';

{
  This function is called during Run Time
  Window: Parent setup window handle
  Variables: The names and values of variables used in the setup script
  State: State of plug-in controls, as chosen during compile time
  Progress: Callback function for progress indicator
  Return: Reserved, set to 0
  NewVariables: Plug-in must return variables received, with modifications, here
  See help for details
}
function RunTimeExecute(Window: THandle; Variables, State: PChar; Progress: TPlugProgressIndicator;
  var Return: Integer; NewVariables: PChar): Integer; stdcall; export;
var
  s: String;
  i: Integer;
  l, lVariables: TStringList;
begin
  if NewVariables = nil then
  begin
    Progress(0, 'Initialize'); // call progress callback, set progress to empty
    Sleep(1000); // wait for a second
    Progress(50, 'Halfway'); // call progress callback, set progress to half full
    lVariables := TStringList.Create;
    l := TStringList.Create;
    lVariables.CommaText := Variables;
    l.CommaText := State;
    {Option1 := l[0] = 'TRUE';
    Variable := l[1];}
    if l[0] = 'TRUE' then s := 'Option1 was selected in IDE'
      else s := 'Option2 was selected in IDE';
    i := MessageBox(Window, PChar(s), 'Example Plug-In Action',
      mb_OKCancel + mb_IconExclamation);
    Progress(100, 'Finalize'); // call progress callback, set progress to full
    if l[1] <> '' then
    begin
      // plug-in returns state in variable
      if i = idOK then
        SetVariable(lVariables, l[1], 'SUCCESS')
      else
        SetVariable(lVariables, l[1], 'ERROR');
    end;    
    // reserved value, set to zero
    Return := 0;
    // save state of variables
    cacheVariables := lVariables.CommaText;
    Result := Length(cacheVariables);
    l.Free;
    lVariables.Free;
  end
  else
  begin
    Result := 0;
    StrCopy(NewVariables, PChar(cacheVariables));
  end;
end;

exports
  RunTimeExecute;

var
  p: PChar;

begin
  GetMem(p, 1024);
  GetModuleFileName(GetModuleHandle('mEXEPlug.dll'), p, 1024);
  ModuleFile := p;
  ModuleFolder := ExtractFilePath(p);
  FreeMem(p);
end.
