{ ============================================================================== }
{ Copyright(c) 1996-2009 InstallAware Software Corporation. All rights reserved. }
{ This source code provided for demonstrative use only. All rights reserved.     }
{ ============================================================================== }

unit uSharedDLL;

interface

uses
  SysUtils, Windows, Classes;

var
  ModuleFile, ModuleFolder: String; // global variables used for storing the plug-in DLL and folder location
  cacheVariables: String; // stores the list of script variables

type
  TPlugProgressIndicator = function(SmartPosition: Integer; Text: PChar): Boolean; stdcall; // progress callback for runtime

{ Use to replace variables used in strings with their values }
function SubstituteVariables(Literal: String; Variables: TStrings): String;

{ Call to get the value of a variable }
function GetVariable(Variables: TStrings; Variable: String): String;
{ Call to set the value of a variable }
procedure SetVariable(Variables: TStrings; Variable: String; Value: String);

implementation

function GetVariable(Variables: TStrings; Variable: String): String;
var
  i: Integer;
begin
  for i := 1 to Variables.Count do
    if ((i -1) mod 2) = 0 then // do we really have a variable at hand?
      if AnsiUpperCase(Variables[i -1]) = AnsiUpperCase(Variable) then
      begin
        Result := Variables[i];
        Exit;
      end;
  raise Exception.Create('Attempting to get value of undefined variable ' + Variable);
end;

procedure SetVariable(Variables: TStrings; Variable: String; Value: String);
var
  i: Integer;
begin
  for i := 1 to Variables.Count do
    if ((i -1) mod 2) = 0 then // do we really have a variable at hand?
      if AnsiUpperCase(Variables[i -1]) = AnsiUpperCase(Variable) then
      begin
        Variables[i] := Value;
        Exit;
      end;
  raise Exception.Create('Attempting to set value of undefined variable ' + Variable);
end;

function SubstituteVariables(Literal: String; Variables: TStrings): String;
var
  i: Integer;
begin
  Result := Literal;
  for i := 1 to Variables.Count do
    if (i -1) mod 2 = 0 then
      Result := StringReplace(Result, '$' + Variables[i -1] + '$',
        Variables[i], [rfReplaceAll, rfIgnoreCase]);
  if Pos('$', Result) <> 0 then
    if Literal <> Result then
      Result := SubstituteVariables(Result, Variables);
end;

end.
